# version 2 pour affichage web
#from codecs import open
import cherrypy, os
import datetime, time
import meteo
from matplotlib import pyplot

class Glob(object):
    motifs = "meteo_web.html" 
    dico_motifs = {}
    abscis = []
    ordon = []
    index = 0
    
def chargermotifs():
    global phrase, label
    
    fiche = open(Glob.motifs, "r", encoding="Utf8")  # lecture du fichier 
    try:
        for ligne in fiche:
            if ligne[:2] =="[*":
                label = ligne[2:]                    # suppression [*
                label = label[:-1].strip()           # suppression LF, espace
                label = label[:-2]                   # suppression *]
                phrase = ""  
            else:
                if ligne[:5] == "#####":
                    Glob.dico_motifs[label] =phrase
                else:
                    phrase += ligne
    finally:
        fiche.close()                                # fermeture du fichier


def misenpg(page):
    return Glob.dico_motifs["enTete"].format(page)


class Pracine(object):
    def index(self):
        nom = cherrypy.session.get("nom", "")
        if nom:
            acces = cherrypy.session["acces"]
            if acces == "Fin":
                return misenpg(Glob.dico_motifs["pageFin"])
            else:
                return misenpg(Glob.dico_motifs["pageGo"].format(nom))
        else:
            return misenpg(Glob.dico_motifs["pageAccueil"])
    index.exposed = True
    
    
    def identification(self, acces="", nom=""):
        cherrypy.session["nom"] = nom
        cherrypy.session["acces"] = acces
        i,da, he, t, p, h, e = 0, "01/Janu/2021", "12h00", 0, 0, 0, 0
        if acces == "Fin":
            return misenpg(Glob.dico_motifs["pageFin"].format(nom))
        else:
            return misenpg(Glob.dico_motifs["pageGo"].format(nom, i, da, he, t, p, h, e))
    identification.exposed = True


    def acquerir(self, acces="", nom=""):
        nom = cherrypy.session["nom"]
        cherrypy.session["acces"] = acces
        
        if acces == "ACQ":
            i = 1
            data_bme = meteo.acquisition()
            journe = data_bme[1]
            horair = data_bme[2]
            temper = data_bme[3]
            pressi = data_bme[4]
            humidi = data_bme[5]
            texter = data_bme[6]

            time.sleep(1)
            Glob.abscis.append(Glob.index)
            Glob.ordon.append(temper)
            afficher(Glob.abscis,Glob.ordon)
            Glob.index = Glob.index + 1
            
            return misenpg(Glob.dico_motifs["pageGo"].format(nom, i, journe, horair, temper, pressi, humidi, texter))
        
        elif acces == "GRAF":
            return misenpg(Glob.dico_motifs["pageAffiche"].format(nom))
        
        else:
            return misenpg(Glob.dico_motifs["pageFin"].format(nom))
    acquerir.exposed = True

def afficher(x, y):  
    color = 'green'

    pyplot.plot(x, y, color, linestyle = 'dashed', linewidth=2, marker='o', markerfacecolor='blue', markersize=5)
    pyplot.xlim(0,6)
    pyplot.xlabel('nbr enr', color = 'red', fontsize = 12)
    pyplot.ylim(10,30)
    pyplot.ylabel('T en °C', color = 'blue', fontsize = 10)
    pyplot.grid(b=True)
    pyplot.title('Evolution température')
    pyplot.savefig('/home/pi/Tp_connect/Station_meteo/annexes/graph3.png')
#    pyplot.show()


#### programme principal ######
chargermotifs()
cherrypy.config.update({"tools.staticdir.root": os.getcwd()})
cherrypy.quickstart(Pracine(), config="meteo_conf_web.conf")    # lancement du serveur